-- ----------------------------------------------------
-- Exampel DWH schema complying SCD type 2 -----------
-- ----------------------------------------------------
-- ----------------------------------------------------
--                                                  --
-- FACT TABLE                                       --
--                                                  --
-- * fact_item_sales                                --
--                                                  --
-- ----------------------------------------------------
--                                                  --
-- DIMENSION TABLES                                 --
--                                                  --
-- * dim_time                                       --
-- * dim_item                                       --
-- * dim_customer                                   --
-- * dim_store                                      --
--                                                  --
-- ---------------------------------------------------- 

-- fact_item_sales
CREATE TABLE fact_item (
	id_dim_date int NOT NULL,
	id_dim_item int NOT NULL,
	id_dim_customer int NOT NULL,
	id_dim_store int NOT NULL,
	units_sold int NOT NULL,
	units_paid int NOT NULL,
	units_shipped int NOT NULL	
) ENGINE = InnoDB;

-- dim_time
CREATE TABLE dim_date (
  id_dim_date int NOT NULL AUTO_INCREMENT,
  year integer NOT NULL,
  yearquartal_id char(7) NOT NULL,
  yearquartal_desc char(2) NOT NULL,
  yearmonth_id char(7) NOT NULL,
  yearmonth_desc int NOT NULL,
  yearmonth_name char(9) NOT NULL,
  yearweek char(7) NOT NULL,
  fulldate date NOT NULL,
  weekday_indicator char(7) NOT NULL,
  CONSTRAINT dim_date_pkey PRIMARY KEY (id_dim_date),
  CONSTRAINT dim_date_fulldate_key UNIQUE (fulldate)
) ENGINE = InnoDB;

-- dim_item
CREATE TABLE dim_item (
  id_dim_item int NOT NULL AUTO_INCREMENT,
  product_code varchar(30) NOT NULL,
  product_name varchar(60) NOT NULL,
  manufacturer_name varchar(30) NOT NULL,
  start_date date DEFAULT '1970-01-01',
  end_date date DEFAULT '9999-12-31',
  CONSTRAINT dim_item_pkey PRIMARY KEY (id_dim_item)
) ENGINE = InnoDB;

-- dim_customer 
CREATE TABLE dim_customer (
  id_dim_customer int NOT NULL AUTO_INCREMENT,
  customer_code varchar(20) NOT NULL,
  fullname varchar(20) NOT NULL,
  company_name varchar(50) NOT NULL,
  city varchar(30) NOT NULL,
  zip_code varchar(10) NOT NULL,
  country varchar(20) NOT NULL,
  sales_region varchar(30) NOT NULL,
  sales_representative varchar(20) NOT NULL,  
  start_date date NOT NULL DEFAULT '1970-01-01',
  end_date date NOT NULL DEFAULT '9999-12-31',
  CONSTRAINT dim_customer_pkey PRIMARY KEY (id_dim_customer)
) ENGINE = InnoDB;

-- dim_store 
CREATE TABLE dim_store (
  id_dim_store int NOT NULL AUTO_INCREMENT,
  store_code varchar(20) NOT NULL,
  partner boolean  NOT NULL DEFAULT false,
  name varchar(30) NOT NULL,
  address varchar(50) NOT NULL,
  city varchar(30) NOT NULL,
  zip_code varchar(10) NOT NULL,
  country varchar(20) NOT NULL,
  region varchar(30) NOT NULL, 
  start_date date NOT NULL DEFAULT '1970-01-01',
  end_date date NOT NULL DEFAULT '9999-12-31',
  CONSTRAINT dim_store_pkey PRIMARY KEY (id_dim_store)
) ENGINE = InnoDB;